package de.hdm_stuttgart.mi.sda2.usermanage.parse;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;


import de.hdm_stuttgart.mi.sda2.usermanage.rdbms.RdbmsHandler;

public class Parser {
   
   
   final RdbmsHandler rdbmsHandler;

   public Parser(final RdbmsHandler rdbmsHandler, final String groupFile, final String passwdFile)
         throws ParseError {
      this.rdbmsHandler = rdbmsHandler;
      
      final BufferedReader groupStream = openFile(groupFile);
            
      try {
         String line;
         int lineNo = 1;
         while ( null != (line = groupStream.readLine())){
            new Group(line, lineNo++);
         }
      } catch (IOException e) {
         throw new ParseError("Unable to parse '" +
               groupFile+ "' file");
      }
   }
 
   public void insertData() {
      rdbmsHandler.addGroups(Group.groups.values());
   }
   
   BufferedReader openFile (final String filename) 
      throws ParseError {
      try {
         return new BufferedReader(new FileReader(filename));
      } catch (FileNotFoundException e) {
         throw new ParseError("Unable to open file '" + filename + "' for reading");
      }
   }
   
}
